#!/bin/bash
tput setaf 5 
echo -e "\n*******************************************************************************************************************"
echo -e "Instalowanie Go"
echo -e "*******************************************************************************************************************"
tput setaf 2

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Pobieranie archiwum Go"
echo -e "*******************************************************************************************************************"
tput setaf 2
wget https://dl.google.com/go/go1.14.2.linux-amd64.tar.gz

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Rozpakowywanie archiwum"
echo -e "*******************************************************************************************************************"
tput setaf 2
tar -xzf go1.14.2.linux-amd64.tar.gz

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Usuwanie niepotrzebnego pliku tar"
echo -e "*******************************************************************************************************************"
tput setaf 2
rm go1.14.2.linux-amd64.tar.gz

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Przeniesienie plików binarnych Go do katalogu /usr/local"
echo -e "*******************************************************************************************************************"
tput setaf 2
sudo mv go /usr/local
echo -e "Zakończono przenoszenie plików binarnych Go"

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Dodawanie zmiennych środowiskowych Go do pliku bash_profile"
echo -e "*******************************************************************************************************************"
tput setaf 2
cat << 'EOF' >> ~/.profile
export GOROOT=/usr/local/go
export GOPATH=~/go/kind
export PATH=$GOPATH/bin:$GOROOT/bin:$PATH
EOF
echo -e "Zmienne zostały dodane"

tput setaf 5
echo -e "\n*******************************************************************************************************************"
echo -e "Ponowne wczytanie profilu w celu użycia nowych zmiennych"
echo -e "*******************************************************************************************************************"
tput setaf 2
source ~/.profile
echo -e "Profil został wczytany"

tput setaf 3
echo -e "\n*******************************************************************************************************************"
echo -e "Zakończono instalowanie Go"
echo -e "*******************************************************************************************************************"
tput setaf 2

